Subject: RE: iSCSI: multiple intiaitor conflicting with target

From: "Elliott, Robert" <[email-masked]>
Date: Mon, 28 May 2001 20:25:25 -0500

This is a general SCSI issue, not just an iSCSI issue.

If you're sharing a target but not a logical unit, then your only concern is
TARGET RESET.  Access Controls (see T10/99-245r9 and other documents on
http://www.t10.org) helps with this level of sharing.  If multiple
initiators try to use the same iSCSI Name you'll create extra trouble at the
iSCSI level, but that's not supposed to happen.

If you're sharing a logical unit, you need to use tools like reservations
(see SPC-2), persistent reservations (see SPC-2), device locks/memory export
commands (see T10/00-312), and/or back-channel clustering coordination
algorithms (Veritas Clustering, Microsoft Clustering, VMS Clustering, etc).

---
Rob Elliott, Compaq Server Storage
[email-masked]

> -----Original Message-----
> From: Sanjeev Bhagat (TRIPACE/Zoetermeer) [mailto:[email-masked]]
> Sent: Monday, May 28, 2001 7:58 PM
> To: Patrick Stirling
> Cc: 'Lakshmi Ramasubramanian'; Santosh Rao; [email-masked]
> Subject: Re: iSCSI: multiple intiaitor conflicting with 
> target (was Re:
> iSCSI: response to second login (with same ISID)
> 
> 
> Hello Patrick,
> 
> Since the initiators are two different entities working completely
> independent of each other they cannot co-ordinate with each 
> other. iSCSI
> Target also sees these two different initiators in different 
> sessions as
> seperate entities. In the current implementation of iSCSI I 
> guess it is not
> possible for two different initiators to know about each 
> other and so it is
> difficult to resolve this conflicting situation.
> 
> The answer to this problem might be lying in SAM-2 
> specifications. May be I
> am missing something there. Can somebody comment?
> 
> Sanjeev
> 
> >
> > On Mon, 28 May 2001, Sanjeev Bhagat (TRIPACE/Zoetermeer) wrote:
> >
> > > Well the conflict of writing to same sector can still be 
> avoided by
> > > implementaion of some locks in the target but I wonder 
> what will happen
> in
> > > this case where 2 inititators are connected to a target.
> >
> > > From: Lakshmi Ramasubramanian 
> [mailto:[email-masked]]
> > >
> > > Even if the target is capable of supporting multiple 
> initiators, won't
> > > it cause problems  with devices such as disk - say, 
> filesystem from the
> > > two initiators' side attempt to write
> > > to the same sectors (even not intentionally) would cause data
> > > corruption. Is iSCSI layer suppose to guard against this type of
> > > device sharing?
> >
> > Umm, am I missing something here?
> >
> > If 2 initiators want to access the same SCSI device, they 
> must coordinate
> > to avoid clashing with each other. It's not the device's 
> responsibility to
> > prevent this. This is one reason several companies have complicated
> > clustering software.
> >
> > patrick
> > Patrick Stirling
> > VERITAS Software (vendor of complicated clustering software!)
> >
>